const TriggerEvents = require("./lib/TriggerEvents");
const AppEvent = require("./lib/AppEvent");

function singleton(name, ClassInstance) {
  if (window[`singleton_of_${name}`]) {
    return window[`singleton_of_${name}`];
  } else {
    return (window[`singleton_of_${name}`] = new ClassInstance());
  }
}

module.exports = {
  animationControlHelper: require("./lib/animationControlHelper"),
  checkScreenLayout: require("./lib/checkScreenLayout"),
  colorHelper: require("./lib/colorHelper"),
  // dataFetcher: require("./lib/dataFetcher"),
  // dataLoader: require("./lib/dataLoader"),
  deviceDetection: require("./lib/deviceDetection"),
  logger: require("./lib/logger"),
  ThemeComponent: require("./lib/themeComponent").default,
  triggerEvents: singleton("TriggerEvents", TriggerEvents),
  appEvent: singleton("AppEvent", AppEvent),
  urlHelper: require("./lib/urlHelper"),
  youtubeHelper: require("./lib/youtubeHelper")
};
