"use strict";

module.exports = {
  LAYOUT_CLASS_PORTRAIT: "portrait",
  LAYOUT_CLASS_LANDSCAPE: "landscape",
  LAYOUT_CLASS_TICKERTAPE: "tickertape",
  LAYOUT_CLASS_SUPERWIDE: "superwide",
  LAYOUT_CLASS_SQUARE: "square",

  getLayout: function getLayout(forceLayout) {
    var layoutClass = this.LAYOUT_CLASS_LANDSCAPE;
    var _window = window,
        innerWidth = _window.innerWidth,
        innerHeight = _window.innerHeight;


    if (innerWidth / innerHeight > 5.5) {
      layoutClass = this.LAYOUT_CLASS_TICKERTAPE;
    } else if (innerWidth / innerHeight < 5.5 && innerWidth / innerHeight > 2.4) {
      layoutClass = this.LAYOUT_CLASS_SUPERWIDE;
    } else if (innerWidth / innerHeight < 1.1 && innerWidth / innerHeight > 0.7) {
      layoutClass = this.LAYOUT_CLASS_SQUARE;
    } else if (innerHeight > innerWidth) {
      layoutClass = this.LAYOUT_CLASS_PORTRAIT;
    } else if (forceLayout) {
      layoutClass = forceLayout;
    }

    /* WILL BE DEPRECATED with monorepo */
    switch (layoutClass) {
      case this.LAYOUT_CLASS_PORTRAIT:
        document.body.classList.remove(this.LAYOUT_CLASS_LANDSCAPE);
        document.body.classList.add(this.LAYOUT_CLASS_PORTRAIT);
        document.body.classList.remove(this.LAYOUT_CLASS_SQUARE);
        document.body.classList.remove(this.LAYOUT_CLASS_TICKERTAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_SUPERWIDE);
        break;

      case this.LAYOUT_CLASS_SQUARE:
        document.body.classList.remove(this.LAYOUT_CLASS_LANDSCAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_PORTRAIT);
        document.body.classList.add(this.LAYOUT_CLASS_SQUARE);
        document.body.classList.remove(this.LAYOUT_CLASS_TICKERTAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_SUPERWIDE);
        break;

      case this.LAYOUT_CLASS_TICKERTAPE:
        document.body.classList.remove(this.LAYOUT_CLASS_LANDSCAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_PORTRAIT);
        document.body.classList.remove(this.LAYOUT_CLASS_SQUARE);
        document.body.classList.add(this.LAYOUT_CLASS_TICKERTAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_SUPERWIDE);
        break;

      case this.LAYOUT_CLASS_SUPERWIDE:
        document.body.classList.remove(this.LAYOUT_CLASS_LANDSCAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_PORTRAIT);
        document.body.classList.remove(this.LAYOUT_CLASS_SQUARE);
        document.body.classList.remove(this.LAYOUT_CLASS_TICKERTAPE);
        document.body.classList.add(this.LAYOUT_CLASS_SUPERWIDE);
        break;

      default:
        // LAYOUT_CLASS_LANDSCAPE
        document.body.classList.add(this.LAYOUT_CLASS_LANDSCAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_PORTRAIT);
        document.body.classList.remove(this.LAYOUT_CLASS_SQUARE);
        document.body.classList.remove(this.LAYOUT_CLASS_TICKERTAPE);
        document.body.classList.remove(this.LAYOUT_CLASS_SUPERWIDE);
        break;
    }
    /* WILL BE DEPRECATED with monorepo */

    return layoutClass;
  }
};