"use strict";

module.exports = {
  colorLuminance: function colorLuminance(hex, lum) {
    // validate hex string
    hex = String(hex).replace(/[^0-9a-f]/gi, "");
    if (hex.length < 6) {
      hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2];
    }
    lum = lum || 0;
    // convert to decimal and change luminosity
    var rgb = "#";
    var c;
    var i;

    for (i = 0; i < 3; i++) {
      c = parseInt(hex.substr(i * 2, 2), 16);
      c = Math.round(Math.min(Math.max(0, c + c * lum), 255)).toString(16);
      rgb += ("00" + c).substr(c.length);
    }

    return rgb;
  },

  checkContrast: function checkContrast(hex) {
    if (typeof hex !== "string") return false;
    hex = String(hex).replace("#", "");
    var r = parseInt(hex.substr(0, 2), 16);
    var g = parseInt(hex.substr(2, 2), 16);
    var b = parseInt(hex.substr(4, 2), 16);
    var yiq = (r * 299 + g * 587 + b * 114) / 1000;
    // console.log('R= ', r, 'G=', g, 'B=', b, 'YIQ=', yiq)
    return yiq <= 128 ? "dark" : "light";
  },

  hexToRgb: function hexToRgb(hex, opacity) {
    var m = hex.match(/^#?([\da-f]{2})([\da-f]{2})([\da-f]{2})$/i);
    var rgb = {
      r: parseInt(m[1], 16),
      g: parseInt(m[2], 16),
      b: parseInt(m[3], 16)
    };

    return "rgba(" + rgb.r + "," + rgb.g + "," + rgb.b + "," + opacity + ")";
  }
};