"use strict";

function getDeviceOperatingSystem() {
  var userAgent = navigator.userAgent || navigator.vendor || window.opera;
  //   // console.log('device >> ',userAgent)
  // Windows Phone must come first because its UA also contains 'Android'
  if (/windows/i.test(userAgent)) {
    return "windows";
  }

  if (/android/i.test(userAgent)) {
    return "android";
  }

  // iOS detection from: http://stackoverflow.com/a/9039885/177710
  if (/iPad|iPhone|iPod/.test(userAgent) && !window.MSStream) {
    return "ios";
  }

  return "unknown";
}

module.exports = getDeviceOperatingSystem();