"use strict";

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

module.exports = {
  init: function init() {
    /* Create a custom always-on-top element */
    var wrapper = document.createElement("div");
    var logs = document.createElement("pre");
    Object.assign(wrapper.style, {
      display: "flex",
      alignItems: "flex-end",
      position: "absolute",
      bottom: "0px",
      left: "0px",
      width: "100%",
      height: "100%",
      zIndex: 9999,
      overflow: "hidden"
    });

    Object.assign(logs.style, {
      width: "100%",
      background: "rgba(0,0,0,0.5)",
      color: "white",
      fontSize: "12px",
      padding: "0.5em",
      margin: 0
    });

    wrapper.appendChild(logs);
    document.body.appendChild(wrapper);

    /* Stringify objects, avoid circular references */
    var stringify = function stringify(obj) {
      var cache = new Map();
      return JSON.stringify(obj, function (key, value) {
        if ((typeof value === "undefined" ? "undefined" : _typeof(value)) === "object" && value !== null) {
          if (cache.get(value)) {
            return; // circular reference found, discard key
          }
          cache.set(value, true); // store value in our map
        }
        return value;
      });
    };

    /* Extend cosnole.log method */
    window.log = [];
    ["info", "log", "debug", "warn", "error", "table", "trace", "timeEnd", "dir", "dirxml", "assert", "count"].forEach(function (method) {
      var methodCache = console[method];
      console[method] = function () {
        for (var _len = arguments.length, messages = Array(_len), _key = 0; _key < _len; _key++) {
          messages[_key] = arguments[_key];
        }

        methodCache.apply(this, arguments);
        messages.map(function (message) {
          return window.log.push("<code style=\"\n              color: " + (method === "error" ? "red" : method === "warn" ? "yellow" : method === "info" ? "deepskyblue" : "white") + "\n            \">" + ((typeof message === "undefined" ? "undefined" : _typeof(message)) === "object" ? stringify(message) : message) + "</code>");
        });
        logs.innerHTML = window.log.join("\n");
      };
    });
  }
};