"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _webfontloader = require("webfontloader");

var _webfontloader2 = _interopRequireDefault(_webfontloader);

var _colorHelper = require("./colorHelper.js");

var _colorHelper2 = _interopRequireDefault(_colorHelper);

var _dataFetcher = require("./dataFetcher");

var _dataFetcher2 = _interopRequireDefault(_dataFetcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable camelcase, react/prop-types */


var ThemeComponent = function (_React$Component) {
  _inherits(ThemeComponent, _React$Component);

  function ThemeComponent(props) {
    _classCallCheck(this, ThemeComponent);

    var _this = _possibleConstructorReturn(this, (ThemeComponent.__proto__ || Object.getPrototypeOf(ThemeComponent)).call(this, props));

    _this.state = {
      themeOptions: {},
      loaded: false
    };
    return _this;
  }

  _createClass(ThemeComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.theme && typeof this.props.theme !== "undefined") {
        this.fetchThemeData(this.props.theme);
      } else {
        this.setState({ loaded: true });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(nextProps, nextState) {
      if (this.props.setGradient) {
        if (nextState.themeOptions.colorBgPrimary !== this.state.themeOptions.colorBgPrimary) {
          this.props.setGradient(nextState.themeOptions.colorBgPrimary);
        }
      }
    }

    // componentWillReceiveProps(nextProps) {
    //   if (
    //     nextProps.theme &&
    //     typeof nextProps.theme !== "undefined" &&
    //     nextProps.theme !== this.props.theme
    //   ) {
    //     this.fetchThemeData(nextProps.theme);
    //   }
    // }

  }, {
    key: "fetchThemeData",
    value: function fetchThemeData(theme) {
      var _this2 = this;

      // new format : organization_id#theme_id
      var themeArray = theme.split("#");
      if (themeArray.length !== 2) {
        // theme format is not match, so ignore loading theme
        this.setState({
          themeOptions: {},
          loaded: true
        });
        return;
      }

      var maxAgeMinute = 0.2;
      var fetchURL = this.getBackendServerURL(); // this.props.server
      var fetchParams = {
        cache_ttl: 60 * maxAgeMinute,
        timeout: 3000,
        data: JSON.stringify({
          organization_id: themeArray[0],
          theme_id: themeArray[1]
        })
      };

      this.getThemeData(fetchURL, fetchParams, maxAgeMinute).then(function (result) {
        if (!result || !result.id || result.id === "default") {
          throw new Error("Theme not found");
        }
        if (_this2.props.getThemeDataObject) {
          _this2.props.getThemeDataObject(result);
        }
        _this2.setState({
          themeOptions: result,
          loaded: true
        });
      }).catch(function (error) {
        console.warn("Fail to get theme " + fetchURL + fetchParams + ";\n" + error);
        if (_this2.props.getThemeDataObject) {
          _this2.props.getThemeDataObject({});
        }
        _this2.setState({
          themeOptions: {},
          loaded: true
        });
      });
    }
  }, {
    key: "validateResultFn",
    value: function validateResultFn(result) {
      if (result.id) {
        return true;
      } else {
        return false;
      }
    }
  }, {
    key: "getBackendServerURL",
    value: function getBackendServerURL() {
      return process.env.REACT_APP_THEME_EDITOR_URL || "https://theme-editor.next.screen.cloud/theme";
    }
  }, {
    key: "getThemeData",
    value: function getThemeData(fetchURL, fetchParams, maxAgeMinute) {
      var _this3 = this;

      return _dataFetcher2.default.getCachedDataForURLParamsMaxAgeMinute(fetchURL, fetchParams, maxAgeMinute).then(function (cachedResult) {
        return cachedResult || _dataFetcher2.default.fetchThenValidateAndCache(fetchURL, fetchParams, _this3.validateResultFn);
      }).then(function (finalResult) {
        return finalResult;
      });
    }
  }, {
    key: "extractGoogleFont",
    value: function extractGoogleFont(googleFontUrl) {
      var customGoogleFont = googleFontUrl.split("family=")[1].split('" rel=')[0].split(":");
      var customGoogleFontName = customGoogleFont[0].replace(/\+/g, " ");
      return customGoogleFontName;
    }
  }, {
    key: "getCustomFontTitle",
    value: function getCustomFontTitle(fontUrl, fontTitle) {
      if (fontUrl.indexOf("fonts.googleapis.com") !== -1) {
        fontTitle = this.extractGoogleFont(fontUrl);
      }
      return fontTitle;
    }
  }, {
    key: "loadCustomFont",
    value: function loadCustomFont(fontUrl, fontTitle) {
      if (fontUrl.indexOf("fonts.googleapis.com") !== -1) {
        // console.log('loadCustomFont Google URL = ', this.extractGoogleFont(fontUrl))
        _webfontloader2.default.load({
          google: {
            families: [this.extractGoogleFont(fontUrl)]
          }
        });
      } else {
        // console.log('loadCustomFont = ', fontTitle, fontUrl)
        _webfontloader2.default.load({
          custom: {
            families: [fontTitle],
            urls: [fontUrl]
          }
        });
      }
    }
  }, {
    key: "applyCustomStyle",
    value: function applyCustomStyle() {
      var customStyle = void 0;
      var themeKeys = Object.keys(this.state.themeOptions) || [];
      if (typeof this.state.themeOptions === "undefined" || !this.state.themeOptions || this.state.themeOptions === {} || themeKeys.length === 0) {
        return "";
      }

      // console.log('this.state.themeOptions = ', this.state.themeOptions)
      // console.log('color-bg-primary = ', this.state.themeOptions.colorBgPrimary)
      // console.log('light or dark text? = ', colorHelper.checkContrast(this.state.themeOptions.colorBgPrimary))

      var theme = this.state.themeOptions;
      var fontUrlHeading = typeof theme.fontUrlHeading !== "undefined" ? theme.fontUrlHeading : "";
      var fontUrlBody = typeof theme.fontUrlBody !== "undefined" ? theme.fontUrlBody : "";
      var fontHeading = typeof theme.fontHeading !== "undefined" ? theme.fontHeading : "";
      var fontBody = typeof theme.fontHeading !== "undefined" ? theme.fontBody : "";
      var linkColor = typeof theme.colorTextLink !== "undefined" ? theme.colorTextLink : "";
      var linkOpacity = void 0;

      if (linkColor !== "") {
        linkOpacity = 1;
      }

      // Webfont Loader
      // console.log('Fonts List =', fontHeading, fontUrlBody, fontBody, fontUrlBody)

      switch (fontHeading) {
        case "Default":
          break;
        case "Custom Heading":
        case "Custom":
          this.loadCustomFont(fontUrlHeading, "Custom Heading");
          fontHeading = this.getCustomFontTitle(fontUrlHeading, "Custom Heading");
          break;
        default:
          _webfontloader2.default.load({
            google: {
              families: [fontHeading]
            }
          });
      }

      switch (fontBody) {
        case "Default":
          break;
        case "Custom Body":
        case "Custom":
          this.loadCustomFont(fontUrlBody, "Custom Body");
          fontBody = this.getCustomFontTitle(fontUrlBody, "Custom Body");
          break;
        default:
          _webfontloader2.default.load({
            google: {
              families: [fontBody]
            }
          });
      }

      customStyle = _react2.default.createElement(
        "style",
        null,
        "\n      @font-face {\n        font-family: \"Custom Heading\";\n        src: url(\"" + fontUrlHeading + "\") format(\"woff2\");\n      }\n      @font-face {\n        font-family: \"Custom Body\";\n        src: url(\"" + fontUrlBody + "\") format(\"woff2\");\n      }\n      .font-heading {\n        font-family: " + fontHeading + ";\n      }\n      .font-body {\n        font-family: " + fontBody + ";\n      }\n      .color-text-link,\n      a {\n        color: " + linkColor + (" !important;\n        opacity: " + (linkOpacity ? linkOpacity : 1) + ";\n      }\n      .color-bg-primary {\n        background-color: ") + theme.colorBgPrimary + " !important;\n      }\n      .color-bg-primary--darker20 {\n        background-color: " + _colorHelper2.default.colorLuminance(theme.colorBgPrimary, -0.2) + " !important;\n      }\n      .color-bg-primary--text {\n        color: " + theme.colorBgPrimary + " !important;\n      }\n      .color-bg-primary--border {\n        border-color: " + _colorHelper2.default.colorLuminance(theme.colorBgPrimary, -0.2) + " !important;\n      }\n      .color-text-heading {\n        color: " + theme.colorTextHeading + " !important;\n      }\n      .color-text-heading--bg {\n        background-color: " + theme.colorTextHeading + " !important;\n        border-color: " + theme.colorTextHeading + " !important;\n      }\n      .color-text-heading--bg-opacity {\n        background-color: " + _colorHelper2.default.hexToRgb(theme.colorTextHeading, 0.2) + " !important;\n        border-color: " + _colorHelper2.default.hexToRgb(theme.colorTextHeading, 0.2) + " !important;\n      }\n      .color-text-heading--stroke {\n        stroke: " + theme.colorTextHeading + " !important;\n      }\n      .svg-fill-backgrond {\n        fill: " + theme.colorBgPrimary + " !important;\n      }\n      .color-text-heading--fill {\n        fill: " + theme.colorTextHeading + " !important;\n      }\n      .color-text-heading--border {\n        border-color: " + theme.colorTextHeading + " !important;\n      }\n      .color-text-heading--pseudo:before {\n        background-color: " + theme.colorTextHeading + " !important;\n      }\n      .color-text-heading--pseudo:after {\n        background-color: " + theme.colorTextHeading + " !important;\n      }\n      .color-text-body {\n        color: " + theme.colorTextBody + " !important;\n      }\n      .color-text-body--bg {\n        background-color: " + theme.colorTextBody + " !important;\n      }\n      .color-text-body--border {\n        border-color: " + theme.colorTextBody + " !important;\n      }\n      .color-text-bg {\n        color: " + theme.colorBgPrimary + " !important;\n      }\n    "
      );

      return customStyle;
    }
  }, {
    key: "render",
    value: function render() {
      var customStyle = "";
      var themeClassName = "preloadState";
      var checkBgColor = _colorHelper2.default.checkContrast(this.state.themeOptions.colorBgPrimary);
      if (this.state.loaded) {
        themeClassName = "";
        if (this.props.theme) {
          themeClassName = checkBgColor ? "bg-" + checkBgColor : "";
          customStyle = this.applyCustomStyle();
        }
        return _react2.default.createElement(
          "div",
          { id: "theme-container", className: themeClassName },
          this.props.children,
          customStyle
        );
      } else {
        return _react2.default.createElement("div", { id: "theme-container", className: themeClassName });
      }
    }
  }]);

  return ThemeComponent;
}(_react2.default.Component);

exports.default = ThemeComponent;