"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// const { EventEmitter } = require("events");

var constants = require("../constants");
var postLog = require("./postLog");
var TriggerEvents = require("../TriggerEvents");

var AppEvent = function (_TriggerEvents) {
  _inherits(AppEvent, _TriggerEvents);

  function AppEvent() {
    _classCallCheck(this, AppEvent);

    var _this = _possibleConstructorReturn(this, (AppEvent.__proto__ || Object.getPrototypeOf(AppEvent)).call(this));

    _this.connected = false;
    _this.appContainerRef = null;
    _this.app = null;
    _this.auth = null;
    _this.stage = null;

    _this.appConnectSucceeded = _this.appConnectSucceeded.bind(_this);
    _this.appConnectFailed = _this.appConnectFailed.bind(_this);
    _this.appLoadSucceeded = _this.appLoadSucceeded.bind(_this);
    _this.appLoadFailed = _this.appLoadFailed.bind(_this);
    _this.appPlaySucceeded = _this.appPlaySucceeded.bind(_this);
    _this.appPlayFailed = _this.appPlayFailed.bind(_this);
    _this.appPauseSucceeded = _this.appPauseSucceeded.bind(_this);
    _this.appPauseFailed = _this.appPauseFailed.bind(_this);
    _this.appStopSucceeded = _this.appStopSucceeded.bind(_this);
    _this.appStopFailed = _this.appStopFailed.bind(_this);
    _this.appDisconnectSucceeded = _this.appDisconnectSucceeded.bind(_this);
    _this.appDisconnectFailed = _this.appDisconnectFailed.bind(_this);
    _this.resourceFetchSucceeded = _this.resourceFetchSucceeded.bind(_this);
    _this.resourceFetchFailed = _this.resourceFetchFailed.bind(_this);
    _this.dataFetchSucceeded = _this.dataFetchSucceeded.bind(_this);
    _this.dataFetchFailed = _this.dataFetchFailed.bind(_this);
    _this.wsConnectionSucceeded = _this.wsConnectionSucceeded.bind(_this);
    _this.wsConnectionFailed = _this.wsConnectionFailed.bind(_this);
    _this.wsConnectionFailed = _this.wsConnectionFailed.bind(_this);
    _this.error = _this.error.bind(_this);
    _this.log = _this.log.bind(_this);

    subscribeToContainerEvents.call(_this);
    return _this;
  }

  _createClass(AppEvent, [{
    key: "appConnectSucceeded",
    value: function appConnectSucceeded(data) {
      this.connected = true;
      sendEventToContainer.call(this, constants.APP_CONNECT_SUCCEDED, data);
    }
  }, {
    key: "appConnectFailed",
    value: function appConnectFailed(data) {
      sendEventToContainer.call(this, constants.APP_CONNECT_FAILED, data);
    }
  }, {
    key: "appLoadSucceeded",
    value: function appLoadSucceeded(data) {
      sendEventToContainer.call(this, constants.APP_LOAD_SUCCEEDED, data);
    }
  }, {
    key: "appLoadFailed",
    value: function appLoadFailed(data) {
      sendEventToContainer.call(this, constants.APP_LOAD_FAILED, data);
    }
  }, {
    key: "appPlaySucceeded",
    value: function appPlaySucceeded(data) {
      sendEventToContainer.call(this, constants.APP_PLAY_SUCCEEDED, data);
    }
  }, {
    key: "appPlayFailed",
    value: function appPlayFailed(data) {
      sendEventToContainer.call(this, constants.APP_PLAY_FAILED, data);
    }
  }, {
    key: "appPauseSucceeded",
    value: function appPauseSucceeded(data) {
      sendEventToContainer.call(this, constants.APP_PAUSE_SUCCEEDED, data);
    }
  }, {
    key: "appPauseFailed",
    value: function appPauseFailed(data) {
      sendEventToContainer.call(this, constants.APP_PAUSE_FAILED, data);
    }
  }, {
    key: "appStopSucceeded",
    value: function appStopSucceeded(data) {
      sendEventToContainer.call(this, constants.APP_STOP_SUCCEEDED, data);
    }
  }, {
    key: "appStopFailed",
    value: function appStopFailed(data) {
      sendEventToContainer.call(this, constants.APP_STOP_FAILED, data);
    }
  }, {
    key: "appDisconnectSucceeded",
    value: function appDisconnectSucceeded(data) {
      this.connected = false;
      sendEventToContainer.call(this, constants.APP_DISCONNECT_SUCCEEDED, data);
    }
  }, {
    key: "appDisconnectFailed",
    value: function appDisconnectFailed(data) {
      sendEventToContainer.call(this, constants.APP_DISCONNECT_FAILED, data);
    }
  }, {
    key: "resourceFetchSucceeded",
    value: function resourceFetchSucceeded(data) {
      sendEventToContainer.call(this, constants.RESOURCE_FETCH_SUCCEEDED, data);
    }
  }, {
    key: "resourceFetchFailed",
    value: function resourceFetchFailed(data) {
      sendEventToContainer.call(this, constants.RESOURCE_FETCH_FAILED, data);
    }
  }, {
    key: "dataFetchSucceeded",
    value: function dataFetchSucceeded(data) {
      sendEventToContainer.call(this, constants.DATA_FETCH_SUCCEEDED, data);
    }
  }, {
    key: "dataFetchFailed",
    value: function dataFetchFailed(data) {
      sendEventToContainer.call(this, constants.DATA_FETCH_FAILED, data);
    }
  }, {
    key: "wsConnectionSucceeded",
    value: function wsConnectionSucceeded(data) {
      sendEventToContainer.call(this, constants.WS_CONNECTION_SUCCEEDED, data);
    }
  }, {
    key: "wsConnectionFailed",
    value: function wsConnectionFailed(data) {
      sendEventToContainer.call(this, constants.WS_CONNECTION_FAILED, data);
    }
  }, {
    key: "error",
    value: function error(data) {
      sendEventToContainer.call(this, constants.APP_ERROR, data);
    }
  }, {
    key: "log",
    value: function log(data) {
      sendEventToContainer.call(this, constants.APP_LOG, data);
    }
  }]);

  return AppEvent;
}(TriggerEvents);

function subscribeToContainerEvents() {
  this.appContainerRef = window.opener || window.parent;
  window.addEventListener("message", listener.bind(this));
}

function sendEventToContainer(type) {
  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var eventData = stringifyJSON({
    type: type,
    data: data
  });
  postLog(type, data, this.app, this.auth, this.stage);
  this.appContainerRef.postMessage(eventData, "*");
}

function listener(event) {
  var _parseJSON = parseJSON(event.data),
      type = _parseJSON.type,
      data = _parseJSON.data;

  switch (type) {
    case constants.APP_CONNECT:
      if (!this.connected) {
        this.app = data.app;
        this.auth = data.auth;
        this.stage = data.stage;
        postLog(type, data.data, this.app, this.auth, this.stage);
        this.emit(constants.APP_CONNECT, data);
      } else {
        console.warn("Already connected to container");
      }
      break;
    case constants.APP_LOAD:
      if (this.connected) {
        postLog(type, data, this.app, this.auth, this.stage);
        this.emit(constants.APP_LOAD, data);
      } else {
        console.warn("Not connected to container");
      }
      break;
    case constants.APP_PLAY:
      if (this.connected) {
        postLog(type, data, this.app, this.auth, this.stage);
        this.emit(constants.APP_PLAY, data);
      } else {
        console.warn("Not connected to container");
      }
      break;
    case constants.APP_PAUSE:
      if (this.connected) {
        postLog(type, data, this.app, this.auth, this.stage);
        this.emit(constants.APP_PAUSE, data);
      } else {
        console.warn("Not connected to container");
      }
      break;
    case constants.APP_STOP:
      if (this.connected) {
        postLog(type, data, this.app, this.auth, this.stage);
        this.emit(constants.APP_STOP, data);
      } else {
        console.warn("Not connected to container");
      }
      break;
    case constants.APP_DISCONNECT:
      if (this.connected) {
        postLog(type, data, this.app, this.auth, this.stage);
        this.emit(constants.APP_DISCONNECT, data);
      } else {
        console.warn("Not connected to container");
      }
      break;
    default:
      break;
  }
}

function parseJSON(string) {
  try {
    return JSON.parse(string);
  } catch (e) {
    return {};
  }
}

function stringifyJSON(object) {
  try {
    return JSON.stringify(object);
  } catch (e) {
    return null;
  }
}

module.exports = AppEvent;