"use strict";

function _extractURL(message) {
  var urlRegex = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gi;
  var urls = message.match(urlRegex);
  if (urls === null) urls = [];
  return urls;
}

function _getYouTubeVideoId(url) {
  var youtubeUrlRegex = /^.*(?:(?:youtu\.be\/|v\/|vi\/|u\/\w\/|embed\/)|(?:(?:watch)?\?v(?:i)?=|\&v(?:i)?=))([^#\&\?]*).*/;
  var result = url.match(youtubeUrlRegex);
  if (result) {
    return result[1];
  } else {
    return "";
  }
}

module.exports = {
  extractYoutTubeIds: function extractYoutTubeIds(string) {
    var allURLS = _extractURL(string);
    var validYouTubeURLs = [];
    for (var idx = 0; idx < allURLS.length; idx++) {
      var url = allURLS[idx];
      // console.log('check url[' + idx + '] : ' + url)
      if (this.isValidYouTubeURL(url)) {
        validYouTubeURLs.push(_getYouTubeVideoId(url));
      }
    }
    // console.log('validYouTubeURLs = ', validYouTubeURLs)
    return validYouTubeURLs;
  },
  isContainYouTubeURL: function isContainYouTubeURL(string) {
    var allURLS = _extractURL(string);
    var foundYouTubeURL = false;
    for (var idx = 0; idx < allURLS.length; idx++) {
      var url = allURLS[idx];
      // console.log('check url[' + idx + '] : ' + url)
      if (this.isValidYouTubeURL(url)) {
        foundYouTubeURL = true;
      }
    }
    return foundYouTubeURL;
  },
  isValidYouTubeURL: function isValidYouTubeURL(url) {
    var regExp = /^.*(youtu\.be\/|v\/|u\/\w\/|embed\/|watch\?v=|\&v=)([^#\&\?]*).*/;
    var match = url.match(regExp);
    if (match && match[2].length == 11) {
      return true; // match[2]
    } else {
      //error
      return false;
    }
  }
};